[求助]如何保存缩略图?
<p>打开后关闭并保存</p><p>Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.Open(operFilePath, false);</p><p>Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;<br/> Database db = doc.Database;<br/> Editor ed = doc.Editor;</p><p>savepath = operFilePath;<br/> doc.CloseAndSave(savepath);</p><p>之后,发现如果原来图形有缩略图的,保存之后还会有缩略图,原来没有缩略图的,保存之后还是没有。但是原来没有缩略图的,我手工打开DWG,然后保存一下就有缩略图了。</p><p>请问如何把缩略图保存出来?</p> 命令 : BLOCKICON <p>没用啊</p><p><font color="#f73809">for (iDwg = 0; iDwg < dwgCount; iDwg++)<br/> {<br/> operFilePath = dwgFilesRoute.ToString();//获得操作图形路径<br/> if (fileType=="DWG")<br/> {<br/> Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.Open(operFilePath, false);<br/> } <br/> else//DXF<br/> {<br/> Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.Open(operFilePath, true);<br/> }<br/></font> </p><p><font color="#ff3300"> Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;<br/> Database db = doc.Database;<br/> Editor ed = doc.Editor;</font><br/> //db.CloseInput(true);<br/> //DocumentLock lok = doc.LockDocument();</p><p> //Utils.ZoomObjects(true);//范围缩放视图<br/> //curVtr = ed.GetCurrentView();<br/> //Point2d d2d = new Point2d(curVtr.Target.X, curVtr.Target.Y);<br/> //curVtr.CenterPoint = new Point2d(0, 0);<br/> //curVtr.Target = new Point3d(0, 0, 0);<br/> //curVtr.ViewDirection = new Vector3d(0, 0, 1);<br/> //curVtr.CenterPoint = d2d;</p><p> //ed.SetCurrentView(curVtr);</p><p> //lok.Dispose();<br/> <font color="#f73809">doc.SendStringToExecute("BLOCKICON",true,false,false);</font></p><p><br/> //db.Save();<br/> labelExecuteCondition.Text = "正在范围缩放" + System.IO.Path.GetFileName(operFilePath) + "视图,请等待……";<br/> labelExecuteCondition.Visible = true;<br/> finish = (int)((Double)(iDwg + 1) / (Double)(dwgCount) * 100);<br/> progressBar1.Value = finish;<br/> progressBar1.Visible = true;<br/> this.Update();<br/> //savepath = System.IO.Path.GetDirectoryName(operFilePath) + System.IO.Path.GetFileNameWithoutExtension(operFilePath);<br/> //savepath = folderPath+System.IO.Path.GetFileNameWithoutExtension(operFilePath);<br/> //savepath = "D:\\杂记<a href="file://\\1">\\1</a>";<br/> <font color="#ff0000">savepath = operFilePath;<br/> doc.CloseAndSave(savepath);</font><br/> //try<br/> //{<br/> // doc.CloseAndSave(savepath);<br/> //}<br/> //catch (System.Exception eRR)<br/> //{<br/> // doc.CloseAndSave(temppath);<br/> // if (fso.FileExists(operFilePath))<br/> // {<br/> // fso.DeleteFile(operFilePath, true);<br/> // }</p><p> // fso.MoveFile(temppath, operFilePath);<br/> //}</p><p> //if(fileType=="DWG")<br/> //{<br/> // doc.CloseAndSave(savepath);<br/> //}</p><p> //if (fileType == "DXF")<br/> //{<br/> // doc.CloseAndSave(temppath);<br/> // if (fso.FileExists(operFilePath))<br/> // {<br/> // fso.DeleteFile(operFilePath, true);<br/> // }</p><p> // fso.MoveFile(temppath, operFilePath);<br/> //}</p><p> }</p> <p>汗,搞错,blockicon是生成块图标的:)</p><p>不过缩略图为什么需要?</p><p>可以试下Wblock或直接调用Save命令</p> <p>算了,缩略图不要也罢</p><p></p><p>只是有个问题,就是比如点击一个按钮,但是按钮执行的是一个循环,循环体如果使用editor发送命令,无论什么命令,都不执行。</p><p>还有,如果不是循环,那么发送的命令会在这个按钮事件函数全部执行完毕之后,CAD开始执行发送的命令。不知道这是为什么。</p><p><br/> public void modify()<br/> {<br/> <br/> <br/> DwgFrame Fra = new DwgFrame();<br/> Autodesk.AutoCAD.ApplicationServices.Application.ShowModelessDialog(Fra);<br/> }</p><p>DwgFrame 是一个窗体,上面有按钮。不知道怎样才能让按钮事件中发送的命令立即执行,执行之后再回到按钮事件继续往下执行?</p> <p><font color="#f73809">SendStringToExecute会产生延时,试下这个</font></p><p><a href="http://bbs.mjtd.com/forum.php?mod=viewthread&tid=78074">http://bbs.mjtd.com/forum.php?mod=viewthread&tid=78074</a></p>
页:
[1]